module RadLength where

radius x1 y1 r1 x2 y2 r2 a b r = do
  rad
  where rad = (sqrt((xa-xb)^2+(ya-yb)^2))/2
        xa = (4*x1^3 - 4*x2*x1^2 - 4*r1^2*x1 + 4*r2^2*x1 - 
      		4*x2^2*x1 + 4*y1^2*x1 - 4*y2^2*x1 - 8*b*y1*x1 + 
      		8*b*y2*x1 + 4*x2^3 + 8*a*y1^2 - 4*x2*y1^2 + 
      		8*a*y2^2 + 4*x2*y2^2 + 4*r1^2*x2 - 4*r2^2*x2 + 
      		8*b*x2*y1 - 8*b*x2*y2 - 16*a*y1*y2 - 
      		sqrt((-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 4*r2^2*x1 + 
          	4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 8*b*y1*x1 - 
          	8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 4*x2*y1^2 - 
          	8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 4*r2^2*x2 - 
          	8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^2 - 
        	4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	          8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 2*x1^2*r1^2 + 
	          2*x2^2*r1^2 - 2*y1^2*r1^2 + 2*y2^2*r1^2 + 
	          4*b*y1*r1^2 - 4*b*y2*r1^2 + r2^4 + x1^4 + x2^4 + 
	          y1^4 + y2^4 - 4*b*y1^3 - 4*b*y2^3 + 2*r2^2*x1^2 - 
	          2*r2^2*x2^2 - 2*x1^2*x2^2 + 4*a^2*y1^2 + 
	          4*b^2*y1^2 - 4*r^2*y1^2 + 2*r2^2*y1^2 + 
	          2*x1^2*y1^2 - 2*x2^2*y1^2 + 4*a^2*y2^2 + 
	          4*b^2*y2^2 - 4*r^2*y2^2 - 2*r2^2*y2^2 - 
	          2*x1^2*y2^2 + 2*x2^2*y2^2 - 2*y1^2*y2^2 + 
	          4*b*y1*y2^2 - 4*b*r2^2*y1 - 4*b*x1^2*y1 + 
	          4*b*x2^2*y1 + 4*b*r2^2*y2 + 4*b*x1^2*y2 - 
	          4*b*x2^2*y2 + 4*b*y1^2*y2 - 8*a^2*y1*y2 - 
	          8*b^2*y1*y2 + 8*r^2*y1*y2)))/
	     	  (2*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
       		  8*y1*y2))
 
	ya = (1/(2*y1 - 2*y2))*
	     (x1^2 - r1^2 + r2^2 - x2^2 + y1^2 - y2^2 + 
	      (x1*sqrt((-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 
	            4*r2^2*x1 + 4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 
	            8*b*y1*x1 - 8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 
	            4*x2*y1^2 - 8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 
	            4*r2^2*x2 - 8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^
	           2 - 4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	            4*y2^2 - 8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 
	            2*x1^2*r1^2 + 2*x2^2*r1^2 - 2*y1^2*r1^2 + 
	            2*y2^2*r1^2 + 4*b*y1*r1^2 - 4*b*y2*r1^2 + 
	            r2^4 + x1^4 + x2^4 + y1^4 + y2^4 - 4*b*y1^3 - 
	            4*b*y2^3 + 2*r2^2*x1^2 - 2*r2^2*x2^2 - 
	            2*x1^2*x2^2 + 4*a^2*y1^2 + 4*b^2*y1^2 - 
	            4*r^2*y1^2 + 2*r2^2*y1^2 + 2*x1^2*y1^2 - 
	            2*x2^2*y1^2 + 4*a^2*y2^2 + 4*b^2*y2^2 - 
	            4*r^2*y2^2 - 2*r2^2*y2^2 - 2*x1^2*y2^2 + 
	            2*x2^2*y2^2 - 2*y1^2*y2^2 + 4*b*y1*y2^2 - 
	            4*b*r2^2*y1 - 4*b*x1^2*y1 + 4*b*x2^2*y1 + 
	            4*b*r2^2*y2 + 4*b*x1^2*y2 - 4*b*x2^2*y2 + 
	            4*b*y1^2*y2 - 8*a^2*y1*y2 - 8*b^2*y1*y2 + 
	            8*r^2*y1*y2)))/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 
	        4*y1^2 + 4*y2^2 - 8*y1*y2) - 
	      (x2*sqrt((-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 
	            4*r2^2*x1 + 4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 
	            8*b*y1*x1 - 8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 
	            4*x2*y1^2 - 8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 
	            4*r2^2*x2 - 8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^
	           2 - 4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	            4*y2^2 - 8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 
	            2*x1^2*r1^2 + 2*x2^2*r1^2 - 2*y1^2*r1^2 + 
	            2*y2^2*r1^2 + 4*b*y1*r1^2 - 4*b*y2*r1^2 + 
	            r2^4 + x1^4 + x2^4 + y1^4 + y2^4 - 4*b*y1^3 - 
	            4*b*y2^3 + 2*r2^2*x1^2 - 2*r2^2*x2^2 - 
	            2*x1^2*x2^2 + 4*a^2*y1^2 + 4*b^2*y1^2 - 
	            4*r^2*y1^2 + 2*r2^2*y1^2 + 2*x1^2*y1^2 - 
	            2*x2^2*y1^2 + 4*a^2*y2^2 + 4*b^2*y2^2 - 
	            4*r^2*y2^2 - 2*r2^2*y2^2 - 2*x1^2*y2^2 + 
	            2*x2^2*y2^2 - 2*y1^2*y2^2 + 4*b*y1*y2^2 - 
	            4*b*r2^2*y1 - 4*b*x1^2*y1 + 4*b*x2^2*y1 + 
	            4*b*r2^2*y2 + 4*b*x1^2*y2 - 4*b*x2^2*y2 + 
	            4*b*y1^2*y2 - 8*a^2*y1*y2 - 8*b^2*y1*y2 + 
	            8*r^2*y1*y2)))/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 
	        4*y1^2 + 4*y2^2 - 8*y1*y2) + (4*r1^2*x1^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) - (4*r2^2*x1^2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
	      (4*x1^4)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (8*r1^2*x1*x2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (8*r2^2*x1*x2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (8*x1^3*x2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) + (4*r1^2*x2^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) - (4*r2^2*x2^2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
	      (8*x1*x2^3)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) + (4*x2^4)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (8*b*x1^2*y1)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (16*b*x1*x2*y1)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (8*b*x2^2*y1)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
	      (8*a*x1*y1^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (4*x1^2*y1^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (8*a*x2*y1^2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (8*x1*x2*y1^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (4*x2^2*y1^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) - (8*b*x1^2*y2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (16*b*x1*x2*y2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (8*b*x2^2*y2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (16*a*x1*y1*y2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
	      (16*a*x2*y1*y2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (8*a*x1*y2^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (4*x1^2*y2^2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (8*a*x2*y2^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (8*x1*x2*y2^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (4*x2^2*y2^2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2)) 
	xb = (4*x1^3 - 4*x2*x1^2 - 4*r1^2*x1 + 4*r2^2*x1 - 
	      4*x2^2*x1 + 4*y1^2*x1 - 4*y2^2*x1 - 8*b*y1*x1 + 
	      8*b*y2*x1 + 4*x2^3 + 8*a*y1^2 - 4*x2*y1^2 + 
	      8*a*y2^2 + 4*x2*y2^2 + 4*r1^2*x2 - 4*r2^2*x2 + 
	      8*b*x2*y1 - 8*b*x2*y2 - 16*a*y1*y2 + 
	      sqrt((-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 4*r2^2*x1 + 
	          4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 8*b*y1*x1 - 
	          8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 4*x2*y1^2 - 
	          8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 4*r2^2*x2 - 
	          8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^2 - 
	        4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	          8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 2*x1^2*r1^2 + 
	          2*x2^2*r1^2 - 2*y1^2*r1^2 + 2*y2^2*r1^2 + 
	          4*b*y1*r1^2 - 4*b*y2*r1^2 + r2^4 + x1^4 + x2^4 + 
	          y1^4 + y2^4 - 4*b*y1^3 - 4*b*y2^3 + 2*r2^2*x1^2 - 
	          2*r2^2*x2^2 - 2*x1^2*x2^2 + 4*a^2*y1^2 + 
	          4*b^2*y1^2 - 4*r^2*y1^2 + 2*r2^2*y1^2 + 
	          2*x1^2*y1^2 - 2*x2^2*y1^2 + 4*a^2*y2^2 + 
	          4*b^2*y2^2 - 4*r^2*y2^2 - 2*r2^2*y2^2 - 
	          2*x1^2*y2^2 + 2*x2^2*y2^2 - 2*y1^2*y2^2 + 
	          4*b*y1*y2^2 - 4*b*r2^2*y1 - 4*b*x1^2*y1 + 
	          4*b*x2^2*y1 + 4*b*r2^2*y2 + 4*b*x1^2*y2 - 
	          4*b*x2^2*y2 + 4*b*y1^2*y2 - 8*a^2*y1*y2 - 
	          8*b^2*y1*y2 + 8*r^2*y1*y2)))/
	     (2*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	       8*y1*y2))
	yb = (1/(2*y1 - 2*y2))*
	     (x1^2 - r1^2 + r2^2 - x2^2 + y1^2 - y2^2 - 
	      (x1*sqrt((-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 
	            4*r2^2*x1 + 4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 
	            8*b*y1*x1 - 8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 
	            4*x2*y1^2 - 8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 
	            4*r2^2*x2 - 8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^
	           2 - 4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	            4*y2^2 - 8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 
	            2*x1^2*r1^2 + 2*x2^2*r1^2 - 2*y1^2*r1^2 + 
	            2*y2^2*r1^2 + 4*b*y1*r1^2 - 4*b*y2*r1^2 + 
	            r2^4 + x1^4 + x2^4 + y1^4 + y2^4 - 4*b*y1^3 - 
	            4*b*y2^3 + 2*r2^2*x1^2 - 2*r2^2*x2^2 - 
	            2*x1^2*x2^2 + 4*a^2*y1^2 + 4*b^2*y1^2 - 
	            4*r^2*y1^2 + 2*r2^2*y1^2 + 2*x1^2*y1^2 - 
	            2*x2^2*y1^2 + 4*a^2*y2^2 + 4*b^2*y2^2 - 
	            4*r^2*y2^2 - 2*r2^2*y2^2 - 2*x1^2*y2^2 + 
	            2*x2^2*y2^2 - 2*y1^2*y2^2 + 4*b*y1*y2^2 - 
	            4*b*r2^2*y1 - 4*b*x1^2*y1 + 4*b*x2^2*y1 + 
	            4*b*r2^2*y2 + 4*b*x1^2*y2 - 4*b*x2^2*y2 + 
	            4*b*y1^2*y2 - 8*a^2*y1*y2 - 8*b^2*y1*y2 + 
	            8*r^2*y1*y2)))/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 
	        4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (x2*sqrt((-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 
	            4*r2^2*x1 + 4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 
	            8*b*y1*x1 - 8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 
	            4*x2*y1^2 - 8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 
	            4*r2^2*x2 - 8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^
	           2 - 4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	            4*y2^2 - 8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 
	            2*x1^2*r1^2 + 2*x2^2*r1^2 - 2*y1^2*r1^2 + 
	            2*y2^2*r1^2 + 4*b*y1*r1^2 - 4*b*y2*r1^2 + 
	            r2^4 + x1^4 + x2^4 + y1^4 + y2^4 - 4*b*y1^3 - 
	            4*b*y2^3 + 2*r2^2*x1^2 - 2*r2^2*x2^2 - 
	            2*x1^2*x2^2 + 4*a^2*y1^2 + 4*b^2*y1^2 - 
	            4*r^2*y1^2 + 2*r2^2*y1^2 + 2*x1^2*y1^2 - 
	            2*x2^2*y1^2 + 4*a^2*y2^2 + 4*b^2*y2^2 - 
	            4*r^2*y2^2 - 2*r2^2*y2^2 - 2*x1^2*y2^2 + 
	            2*x2^2*y2^2 - 2*y1^2*y2^2 + 4*b*y1*y2^2 - 
	            4*b*r2^2*y1 - 4*b*x1^2*y1 + 4*b*x2^2*y1 + 
	            4*b*r2^2*y2 + 4*b*x1^2*y2 - 4*b*x2^2*y2 + 
	            4*b*y1^2*y2 - 8*a^2*y1*y2 - 8*b^2*y1*y2 + 
	            8*r^2*y1*y2)))/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 
	        4*y1^2 + 4*y2^2 - 8*y1*y2) + (4*r1^2*x1^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) - (4*r2^2*x1^2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
	      (4*x1^4)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (8*r1^2*x1*x2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (8*r2^2*x1*x2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (8*x1^3*x2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) + (4*r1^2*x2^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) - (4*r2^2*x2^2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
	      (8*x1*x2^3)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) + (4*x2^4)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (8*b*x1^2*y1)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (16*b*x1*x2*y1)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (8*b*x2^2*y1)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
	      (8*a*x1*y1^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (4*x1^2*y1^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (8*a*x2*y1^2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (8*x1*x2*y1^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (4*x2^2*y1^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) - (8*b*x1^2*y2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (16*b*x1*x2*y2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (8*b*x2^2*y2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (16*a*x1*y1*y2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
	      (16*a*x2*y1*y2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (8*a*x1*y2^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (4*x1^2*y2^2)/(4*x1^2 - 8*x2*x1 + 
	        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
	      (8*a*x2*y2^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
	        4*y2^2 - 8*y1*y2) - (8*x1*x2*y2^2)/
	       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
	        8*y1*y2) + (4*x2^2*y2^2)/(4*x1^2 - 8*x2*x1 + 
        	4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2))