import Graphics.Rendering.OpenGL
import Graphics.UI.GLUT  as GLUT

import OrbitPointOfView 
import StateUtil
import Hexlet
import TrivialHexlet

main = do
  (progName,_) <-  getArgsAndInitialize
  initialDisplayMode $= [WithDepthBuffer,DoubleBuffered]
  createWindow progName
  depthFunc $= Just Less
  windowSize $= Size 800 800
  
  pPos <- new (90::Int,270::Int,1.0)
  keyboardMouseCallback $= Just (keyboard pPos)

  displayCallback $= display pPos
  reshapeCallback $= Just reshape
  mainLoop

display pPos = do
  loadIdentity
  setPointOfView pPos
  clear [ColorBuffer,DepthBuffer]
 -- (hexlet 0 0 0 0.4 0.3 0.11 0.17 0.15)
  (hexlet 0 0 0 0.4 0.17 0.17 0.17 0.2)
 -- (hexletTriv 0 0 0 0.3753 0 0.196 0.2)  -- This parameters can be changed as long as they are a valid combination
  swapBuffers

keyboard pPos c _  _ _ = keyForPos pPos c
