module Sphere where

import PointsForRendering
import Graphics.Rendering.OpenGL

spherePoints radius number
  = [let (alpha,beta) = (twoPi * i/number, pi * j/number)
         in (radius*((cos (alpha))*(sin (beta))),radius*((sin (alpha))*(sin (beta))), radius*(cos (beta)))|i<-[1,2..number],j<-[1,2..(number*2)]]
    where
      twoPi = 2 * pi
      
sphere radius = spherePoints radius 100

renderSphereApprox r n
 = displayPoints (spherePoints r n) Points

renderSphere r =  displayPoints (sphere r) Points


